

def build_lodac_config(conf, env_name, dataset_type, risky):
    if env_name == 'walker_walk':
        if dataset_type == 'medium' or dataset_type == 'expert' or dataset_type == 'expert_replay':
            conf.hidden_latent = 256
            conf.units_actor = 256
            conf.num_layers_actor = 3
            conf.critic_units = 256
            conf.act_critic = 'relu'
            conf.act_actor = 'relu'

            conf.latent_batch_size = 64
            conf.latent_batch_length = 50

            conf.clip_rewards = 'none'
            conf.num_layers_rewards = 3
            conf.num_units_reward = 128

            conf.weight_decay = 0.0
            conf.grad_clip = 100

            conf.latent_model_lr = 6e-4
            conf.critic_lr = 3e-4
            conf.actor_lr = 3e-5

            conf.log_every = 1000
            conf.kl_scale = 1.0
            conf.actor_batch_size = 256  # 256

            conf.N_quantile_critic = 32
            conf.target_update_tau = 5e-3

            conf.critic_gamma = 0.99
            conf.actor_update_frequency = 1
            conf.fp = None
            conf.target_fp = None
            conf.tau_type = 'iqn'
            conf.num_random_actions = 10        # for codac penal
            conf.min_z_weight = 1
            conf.with_lagrange = True

            # target action_gap
            if dataset_type == 'medium':
                conf.target_action_gap = 6
                if risky:
                    conf.num_actor_critic_loop = 550
                else:
                    conf.num_actor_critic_loop = 350

            if dataset_type == 'expert':
                conf.target_action_gap = 4
                if risky:
                    conf.num_actor_critic_loop = 550
                else:
                    conf.num_actor_critic_loop = 550

            if dataset_type == 'expert_replay':
                conf.target_action_gap = 6
                if risky:
                    conf.num_actor_critic_loop = 750
                else:
                    conf.num_actor_critic_loop = 1000

            conf.alpha_prime_lr = 3e-4
            conf.use_automatic_entropy = False
            conf.alpha_entropy = 0.2
            conf.alpha_lr = 3e-4
            conf.layer_norm = True

            return conf

        else:
            print("We dont have any configuration for lodac and this type of dataset.")
            raise NotImplementedError(dataset_type)
    else:
        print("We dont have any configuration for lodac and this environment.")
        raise NotImplementedError(env_name)

