

def build_oraac_config(conf, env_name, dataset_type, risky, load_imit_agent=False):
    if env_name == 'walker_walk':
        if dataset_type == 'medium' or dataset_type == 'expert' or dataset_type == 'expert_replay':
            if risky:
                conf.hidden_latent = 256
                conf.units_imit_agent = 256  # 256
                conf.act_imit_agent = 'relu'
                conf.num_layers_imit_agent = 4
                conf.act_imit_agent = 'relu'
                conf.units_cvar_agent = 256
                conf.num_layers_cvar_agent = 3
                conf.act_cvar_agent = 'relu'
                conf.critic_num_layers = 3
                conf.critic_units = 256
                conf.act_critic = 'relu'
                conf.act_actor = 'relu'

                conf.latent_batch_size = 64
                conf.latent_batch_length = 50

                conf.clip_rewards = 'none'
                conf.num_layers_rewards = 3
                conf.num_units_reward = 128

                conf.weight_decay = 0.0
                conf.grad_clip = 100

                conf.latent_model_lr = 6e-4
                conf.critic_lr = 3e-4
                conf.actor_lr = 3e-4
                conf.log_every = 1000
                conf.kl_scale = 1.0
                conf.actor_batch_size = 256  # 256

                conf.trade_off_cvar_imit_agent = 0.25
                conf.load_imit_actor = load_imit_agent

                conf.N_quantile_critic = 32
                conf.critic_hidden_units_state = 256
                conf.critic_hidden_units_action = 256
                conf.critic_hidden_units_f = 32
                conf.critic_tau_embedding_dim = 16
                conf.critic_embedding_dim = 16
                conf.target_update_tau = 0.005
                conf.num_imit_training_steps = 90000

                conf.critic_gamma = 0.99
                conf.actor_update_frequency = 2
                conf.n_quantile_policy = 8

                conf.imit_batch_size = 64  # 64
                conf.imit_actor_lr = 1e-3  # 1e-3

                # load pretrained model
                conf.num_first_synthetic_data = 50000
                conf.num_actor_critic_loop = 100000
                conf.num_imit_actor_training = 12000
                conf.num_actor_critic_training_per_loop = 200
                conf.num_evaluate = 25
                if dataset_type == 'expert':
                    conf.num_actor_critic_loop = 650
                    return conf

                if dataset_type == 'medium':
                    conf.num_actor_critic_loop = 500
                    return conf

                if dataset_type == 'expert_replay':
                    conf.num_actor_critic_loop = 500
                    return conf

            else:
                conf.hidden_latent = 256
                conf.units_imit_agent = 256  # 256
                conf.act_imit_agent = 'relu'
                conf.num_layers_imit_agent = 4
                conf.act_imit_agent = 'relu'
                conf.units_cvar_agent = 256
                conf.num_layers_cvar_agent = 3
                conf.act_cvar_agent = 'relu'
                conf.critic_num_layers = 3
                conf.critic_units = 256
                conf.act_critic = 'relu'
                conf.act_actor = 'relu'

                conf.latent_batch_size = 128
                conf.latent_batch_length = 50

                conf.clip_rewards = 'none'
                conf.num_layers_rewards = 3
                conf.num_units_reward = 128

                conf.weight_decay = 0.0
                conf.grad_clip = 100

                conf.latent_model_lr = 6e-4
                conf.critic_lr = 3e-4
                conf.actor_lr = 3e-4
                conf.log_every = 1000
                conf.kl_scale = 1.0
                conf.actor_batch_size = 256  # 256

                conf.trade_off_cvar_imit_agent = 0.25
                conf.load_imit_actor = load_imit_agent

                conf.N_quantile_critic = 32
                conf.critic_hidden_units_state = 256
                conf.critic_hidden_units_action = 256
                conf.critic_hidden_units_f = 32
                conf.critic_tau_embedding_dim = 16
                conf.critic_embedding_dim = 16
                conf.target_update_tau = 0.005
                conf.num_imit_training_steps = 90000

                conf.critic_gamma = 0.99
                conf.actor_update_frequency = 2
                conf.n_quantile_policy = 8

                conf.imit_batch_size = 64  # 64
                conf.imit_actor_lr = 1e-3  # 1e-3

                # load pretrained model
                conf.num_first_synthetic_data = 50000
                conf.num_actor_critic_loop = 100000
                conf.num_imit_actor_training = 12000
                conf.num_actor_critic_training_per_loop = 200
                conf.num_evaluate = 25

                if dataset_type == 'expert':
                    conf.num_actor_critic_loop = 500
                    return conf

                if dataset_type == 'medium':
                    conf.num_actor_critic_loop = 500
                    return conf

                if dataset_type == 'expert_replay':
                    conf.num_actor_critic_loop = 550
                    return conf

        else:
            print("We dont have any configuration for oraac and this type of dataset.")
            raise NotImplementedError(dataset_type)
    else:
        print("We dont have any configuration for oraac and this environment.")
        raise NotImplementedError(env_name)

