

from wrappers import *
from utils_tools import save_episodes, summarize_episode


def make_env(config, writer, prefix, store=False):
    env = DeepMindControl(config.task)
    env = ActionRepeat(env, config.action_repeat)
    env = NormalizeActions(env)
    env = TimeLimit(env, config.time_limit / config.action_repeat)
    callbacks = []
    if store:
        callbacks.append(lambda ep: save_episodes(config.datadir, [ep]))
    if prefix == 'test':
        callbacks.append(lambda ep: summarize_episode(ep, config, writer, prefix))
    env = Collect(env, callbacks, config.precision)
    env = RewardObs(env)
    return env



